
class Menu_dsl
  include Comparable

  attr_reader :etiqueta, :tit, :porcentaje, :platos, :vct, :proteinas, :grasas, :hidratos_carbono

  def initialize (etiqueta, &block)
    @porcentaje = {}
    @platos = []
    @etiqueta = etiqueta
    instance_eval(&block)
  end

  def titulo(titulo)
    @tit = titulo
  end

  def ingesta(ingest = {})
    @porcentaje[:min] = ingest[:min]
    @porcentaje[:max] = ingest[:max]
  end

  def plato(plat = {})
    plato_auxiliar = Plato.new(plat[:descripcion], plat[:porcion], plat[:gramos])
    platos << plato_auxiliar
  end

  def porcentajes(porcent = {})
    @vct = porcent[:vct]
    @grasas = porcent[:grasas]
    @hidratos_carbono = porcent[:hidratos]
    @proteinas = porcent[:proteinas]
  end

  def <=>(other) #Compara dos objetos de la misma jerarquía basandose en la variable calórica vct
			return @vct <=> other.vct
	end

  def to_s

		string = "#{@tit} (#{@porcentaje[:min]})"
    if(@porcentaje[:max] != nil)then
      string << " (#{@porcentaje[:max]}) \n"
    else
      string << "\n"
    end

    platos.each_with_index do |plato, index|
      string << "- #{plato} \n"
    end

		string << "V.C.T | %	#{@vct} kcal | #{@proteinas} - #{@grasas} - #{@hidratos_carbono}"

		string
	end


  def get_plato(n_plato)
    platos[n_plato].to_s
  end

end




class MenuEdad_dsl < Menu_dsl
attr_accessor :edad

def initialize(edad, etiqueta, &block)
  @edad = edad
  super(etiqueta, &block)
end

end


class MenuAlimentos_dsl < Menu_dsl
  attr_accessor :alimentos

  def initialize(alimentos, etiqueta, &block)
    @alimentos = alimentos
    super(etiqueta, &block)
  end
end
